net.sf.jasperreports.engine.design

## Class JRDesignDataset

- java.lang.Object
- - net.sf.jasperreports.engine.base.JRBaseDataset
  - - net.sf.jasperreports.engine.design.JRDesignDataset

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable, JRChangeEventsSupport, JRCloneable, JRDataset, JRIdentifiable, JRPropertiesHolder

      public class JRDesignDataset
      extends JRBaseDataset

  Implementation of `JRDataset` to be used for report desing.
  Version:
    $Id: JRDesignDataset.java 6782 2013-12-07 00:15:33Z teodord $
  Author:
    Lucian Chirita (lucianc@users.sourceforge.net)
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.util.List<JRField>` | `fieldsList`
    `protected java.util.Map<java.lang.String,JRField>` | `fieldsMap` Fields mapped by name.
    `protected java.util.List<JRGroup>` | `groupsList`
    `protected java.util.Map<java.lang.String,JRGroup>` | `groupsMap` Groups mapped by name.
    `protected java.util.List<JRParameter>` | `parametersList`
    `protected java.util.Map<java.lang.String,JRParameter>` | `parametersMap` Parameters mapped by name.
    `static java.lang.String` | `PROPERTY_FIELDS`
    `static java.lang.String` | `PROPERTY_FILTER_EXPRESSION`
    `static java.lang.String` | `PROPERTY_GROUPS`
    `static java.lang.String` | `PROPERTY_NAME`
    `static java.lang.String` | `PROPERTY_PARAMETERS`
    `static java.lang.String` | `PROPERTY_QUERY`
    `static java.lang.String` | `PROPERTY_RESOURCE_BUNDLE`
    `static java.lang.String` | `PROPERTY_SCRIPTLET_CLASS`
    `static java.lang.String` | `PROPERTY_SCRIPTLETS`
    `static java.lang.String` | `PROPERTY_SORT_FIELDS`
    `static java.lang.String` | `PROPERTY_VARIABLES`
    `protected java.util.List<JRScriptlet>` | `scriptletsList`
    `protected java.util.Map<java.lang.String,JRScriptlet>` | `scriptletsMap` Scriptlets mapped by name.
    `protected java.util.List<JRSortField>` | `sortFieldsList`
    `protected java.util.Map<java.lang.String,JRSortField>` | `sortFieldsMap` Sort fields mapped by name.
    `protected java.util.List<JRVariable>` | `variablesList`
    `protected java.util.Map<java.lang.String,JRVariable>` | `variablesMap` Variables mapped by name.

    - ### Fields inherited from class net.sf.jasperreports.engine.base.JRBaseDataset

      `fields, filterExpression, groups, isMain, name, parameters, propertiesMap, PROPERTY_WHEN_RESOURCE_MISSING_TYPE, query, resourceBundle, scriptletClass, scriptlets, sortFields, uuid, variables, whenResourceMissingTypeValue`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JRDesignDataset(boolean isMain)` Create a dataset.
    `JRDesignDataset(JasperReportsContext jasperReportsContext, boolean isMain)` Create a dataset.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addField(int index, JRField field)` Inserts a field at the specified position into the dataset.
    `void` | `addField(JRField field)` Adds a field to the dataset.
    `void` | `addGroup(int index, JRDesignGroup group)` Inserts a group at the specified position into the dataset.
    `void` | `addGroup(JRDesignGroup group)` Adds a group to the dataset.
    `void` | `addParameter(int index, JRParameter parameter)` Inserts a parameter at the specified position into the dataset.
    `void` | `addParameter(JRParameter parameter)` Adds a parameter to the dataset.
    `void` | `addScriptlet(int index, JRScriptlet scriptlet)` Inserts a scriptlet at the specified position into the dataset.
    `void` | `addScriptlet(JRScriptlet scriptlet)` Adds a scriptlet to the dataset.
    `void` | `addSortField(int index, JRSortField sortField)` Inserts a sort field at specified position into the dataset.
    `void` | `addSortField(JRSortField sortField)` Adds a sort field to the dataset.
    `void` | `addVariable(int index, JRDesignVariable variable)` Inserts a variable at specified position into the dataset.
    `protected void` | `addVariable(int index, JRDesignVariable variable, boolean system)` Inserts a variable at specified position into the dataset.
    `void` | `addVariable(JRDesignVariable variable)` Adds a variable to the dataset.
    `protected void` | `addVariable(JRDesignVariable variable, boolean system)` Adds a variable to the dataset.
    `java.lang.Object` | `clone()`
    `JRField[]` | `getFields()` Returns the dataset's fields.
    `java.util.List<JRField>` | `getFieldsList()` Returns the list of fields.
    `java.util.Map<java.lang.String,JRField>` | `getFieldsMap()` Returns the map of fields indexed by name.
    `JRGroup[]` | `getGroups()` Returns the dataset's groups.
    `java.util.List<JRGroup>` | `getGroupsList()` Returns the list of groups.
    `java.util.Map<java.lang.String,JRGroup>` | `getGroupsMap()` Returns the map of groups indexed by name.
    `JRParameter[]` | `getParameters()` Returns the dataset's parameters.
    `java.util.List<JRParameter>` | `getParametersList()` Returns the list of parameters, including build-in ones.
    `java.util.Map<java.lang.String,JRParameter>` | `getParametersMap()` Returns the map of parameters, including build-in ones, indexed by name.
    `JRScriptlet[]` | `getScriptlets()` Returns the dataset's scriptlets.
    `java.util.List<JRScriptlet>` | `getScriptletsList()` Returns the list of scriptlets, excluding the scriptletClass one.
    `java.util.Map<java.lang.String,JRScriptlet>` | `getScriptletsMap()` Returns the map of scriptlets, excluding the scriptletClass one, indexed by name.
    `JRSortField[]` | `getSortFields()` Returns the dataset's sort fields.
    `java.util.List<JRSortField>` | `getSortFieldsList()` Returns the list of sort fields.
    `java.util.Map<java.lang.String,JRSortField>` | `getSortFieldsMap()` Returns the map of sort fields indexed by name and type.
    `JRVariable[]` | `getVariables()` Returns the dataset's variables.
    `java.util.List<JRVariable>` | `getVariablesList()` Returns the list of variables, including build-in ones.
    `java.util.Map<java.lang.String,JRVariable>` | `getVariablesMap()` Returns the map of variable, including build-in ones, indexed by name.
    `boolean` | `hasUUID()` Determines whether the report has an existing unique identifier.
    `protected void` | `queryLanguageChanged(java.lang.String oldLanguage, java.lang.String newLanguage)`
    `JRField` | `removeField(JRField field)` Removes a field from the dataset.
    `JRField` | `removeField(java.lang.String fieldName)` Removes a field from the dataset.
    `JRGroup` | `removeGroup(JRGroup group)` Removes a group from the dataset.
    `JRGroup` | `removeGroup(java.lang.String groupName)` Removes a group from the dataset.
    `JRParameter` | `removeParameter(JRParameter parameter)` Removes a parameter from the dataset.
    `JRParameter` | `removeParameter(java.lang.String parameterName)` Removes a parameter from the dataset.
    `JRScriptlet` | `removeScriptlet(JRScriptlet scriptlet)` Removes a scriptlet from the dataset.
    `JRScriptlet` | `removeScriptlet(java.lang.String scriptletName)` Removes a scriptlet from the dataset.
    `JRSortField` | `removeSortField(JRSortField sortField)` Removes a sort field from the dataset.
    `JRSortField` | `removeSortField(java.lang.String fieldName)` Deprecated. To be removed.
    `JRVariable` | `removeVariable(JRVariable variable)` Removes a variable from the dataset.
    `JRVariable` | `removeVariable(java.lang.String variableName)` Removes a variable from the dataset.
    `void` | `setFilterExpression(JRExpression expression)` Sets the dataset filter expression.
    `void` | `setName(java.lang.String name)` Sets the name of the dataset.
    `void` | `setProperty(java.lang.String propName, java.lang.String value)` Adds/sets a property value.
    `void` | `setQuery(JRDesignQuery query)` Sets the dataset query.
    `void` | `setResourceBundle(java.lang.String resourceBundle)` Sets the base name of resource bundle to be used by the dataset.
    `void` | `setScriptletClass(java.lang.String scriptletClass)` Sets the scriptlet class name.
    `void` | `setUUID(java.util.UUID uuid)` Sets the unique identifier for the report.

    - ### Methods inherited from class net.sf.jasperreports.engine.base.JRBaseDataset

      `getEventSupport, getFilterExpression, getName, getParentProperties, getPropertiesMap, getQuery, getResourceBundle, getScriptletClass, getUUID, getWhenResourceMissingTypeValue, hasProperties, isMainDataset, setWhenResourceMissingType`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### PROPERTY_FIELDS

          public static final java.lang.String PROPERTY_FIELDS

      See Also:
        Constant Field Values

    - #### PROPERTY_FILTER_EXPRESSION

          public static final java.lang.String PROPERTY_FILTER_EXPRESSION

      See Also:
        Constant Field Values

    - #### PROPERTY_GROUPS

          public static final java.lang.String PROPERTY_GROUPS

      See Also:
        Constant Field Values

    - #### PROPERTY_NAME

          public static final java.lang.String PROPERTY_NAME

      See Also:
        Constant Field Values

    - #### PROPERTY_SCRIPTLETS

          public static final java.lang.String PROPERTY_SCRIPTLETS

      See Also:
        Constant Field Values

    - #### PROPERTY_PARAMETERS

          public static final java.lang.String PROPERTY_PARAMETERS

      See Also:
        Constant Field Values

    - #### PROPERTY_QUERY

          public static final java.lang.String PROPERTY_QUERY

      See Also:
        Constant Field Values

    - #### PROPERTY_RESOURCE_BUNDLE

          public static final java.lang.String PROPERTY_RESOURCE_BUNDLE

      See Also:
        Constant Field Values

    - #### PROPERTY_SCRIPTLET_CLASS

          public static final java.lang.String PROPERTY_SCRIPTLET_CLASS

      See Also:
        Constant Field Values

    - #### PROPERTY_SORT_FIELDS

          public static final java.lang.String PROPERTY_SORT_FIELDS

      See Also:
        Constant Field Values

    - #### PROPERTY_VARIABLES

          public static final java.lang.String PROPERTY_VARIABLES

      See Also:
        Constant Field Values

    - #### scriptletsMap

          protected java.util.Map<java.lang.String,JRScriptlet> scriptletsMap

      Scriptlets mapped by name.

    - #### scriptletsList

          protected java.util.List<JRScriptlet> scriptletsList

    - #### parametersMap

          protected java.util.Map<java.lang.String,JRParameter> parametersMap

      Parameters mapped by name.

    - #### parametersList

          protected java.util.List<JRParameter> parametersList

    - #### fieldsMap

          protected java.util.Map<java.lang.String,JRField> fieldsMap

      Fields mapped by name.

    - #### fieldsList

          protected java.util.List<JRField> fieldsList

    - #### sortFieldsMap

          protected java.util.Map<java.lang.String,JRSortField> sortFieldsMap

      Sort fields mapped by name.

    - #### sortFieldsList

          protected java.util.List<JRSortField> sortFieldsList

    - #### variablesMap

          protected java.util.Map<java.lang.String,JRVariable> variablesMap

      Variables mapped by name.

    - #### variablesList

          protected java.util.List<JRVariable> variablesList

    - #### groupsMap

          protected java.util.Map<java.lang.String,JRGroup> groupsMap

      Groups mapped by name.

    - #### groupsList

          protected java.util.List<JRGroup> groupsList

  - ### Constructor Detail

    - #### JRDesignDataset

          public JRDesignDataset(boolean isMain)

      Create a dataset.
      Parameters:
        `isMain` - whether this is the main dataset of the report or a sub dataset
      See Also:
        `JRDataset.isMainDataset()`

    - #### JRDesignDataset

          public JRDesignDataset(JasperReportsContext jasperReportsContext,
                         boolean isMain)

      Create a dataset.
      Parameters:
        `isMain` - whether this is the main dataset of the report or a sub dataset
      See Also:
        `JRDataset.isMainDataset()`

  - ### Method Detail

    - #### setUUID

          public void setUUID(java.util.UUID uuid)

      Sets the unique identifier for the report.
      Parameters:
        `uuid` - the identifier

    - #### hasUUID

          public boolean hasUUID()

      Determines whether the report has an existing unique identifier. Note that when no existing identifier is set, `JRBaseDataset.getUUID()` would generate and return an identifier.
      Returns:
        whether the report has an externally set unique identifier
      See Also:
        `setUUID(UUID)`

    - #### setName

          public void setName(java.lang.String name)

      Sets the name of the dataset.
      Parameters:
        `name` - the name of the dataset
      See Also:
        `JRDataset.getName()`

    - #### getScriptlets

          public JRScriptlet[] getScriptlets()

      Description copied from interface: `JRDataset`
      Returns the dataset's scriptlets.
      Specified by:
        `getScriptlets` in interface `JRDataset`
      Overrides:
        `getScriptlets` in class `JRBaseDataset`
      Returns:
        the dataset's scriptlets

    - #### getScriptletsList

          public java.util.List<JRScriptlet> getScriptletsList()

      Returns the list of scriptlets, excluding the scriptletClass one.
      Returns:
        list of `JRScriptlet` objects

    - #### getScriptletsMap

          public java.util.Map<java.lang.String,JRScriptlet> getScriptletsMap()

      Returns the map of scriptlets, excluding the scriptletClass one, indexed by name.
      Returns:
        `JRScriptlet` objects indexed by name

    - #### addScriptlet

          public void addScriptlet(JRScriptlet scriptlet)
                            throws JRException

      Adds a scriptlet to the dataset.
      Parameters:
        `scriptlet` - the scriptlet to add
      Throws:
        `JRException`
      See Also:
        `JRDataset.getScriptlets()`

    - #### addScriptlet

          public void addScriptlet(int index,
                          JRScriptlet scriptlet)
                            throws JRException

      Inserts a scriptlet at the specified position into the dataset.
      Parameters:
        `index` - the scriptlet position
        `scriptlet` - the scriptlet to insert
      Throws:
        `JRException`
      See Also:
        `JRDataset.getScriptlets()`

    - #### removeScriptlet

          public JRScriptlet removeScriptlet(java.lang.String scriptletName)

      Removes a scriptlet from the dataset.
      Parameters:
        `scriptletName` - the scriptlet name
      Returns:
        the removed scriptlet, or `null` if the scriptlet was not found

    - #### removeScriptlet

          public JRScriptlet removeScriptlet(JRScriptlet scriptlet)

      Removes a scriptlet from the dataset.
      Parameters:
        `scriptlet` - the scriptlet to be removed
      Returns:
        the scriptlet to be removed

    - #### getParameters

          public JRParameter[] getParameters()

      Description copied from interface: `JRDataset`
      Returns the dataset's parameters.
      Specified by:
        `getParameters` in interface `JRDataset`
      Overrides:
        `getParameters` in class `JRBaseDataset`
      Returns:
        the dataset's parameters

    - #### getParametersList

          public java.util.List<JRParameter> getParametersList()

      Returns the list of parameters, including build-in ones.
      Returns:
        list of `JRParameter` objects

    - #### getParametersMap

          public java.util.Map<java.lang.String,JRParameter> getParametersMap()

      Returns the map of parameters, including build-in ones, indexed by name.
      Returns:
        `JRParameter` objects indexed by name

    - #### addParameter

          public void addParameter(JRParameter parameter)
                            throws JRException

      Adds a parameter to the dataset.
      Parameters:
        `parameter` - the parameter to add
      Throws:
        `JRException`
      See Also:
        `JRDataset.getParameters()`

    - #### addParameter

          public void addParameter(int index,
                          JRParameter parameter)
                            throws JRException

      Inserts a parameter at the specified position into the dataset.
      Parameters:
        `index` - the parameter position
        `parameter` - the parameter to insert
      Throws:
        `JRException`
      See Also:
        `JRDataset.getParameters()`

    - #### removeParameter

          public JRParameter removeParameter(java.lang.String parameterName)

      Removes a parameter from the dataset.
      Parameters:
        `parameterName` - the parameter name
      Returns:
        the removed parameter, or `null` if the parameter was not found

    - #### removeParameter

          public JRParameter removeParameter(JRParameter parameter)

      Removes a parameter from the dataset.
      Parameters:
        `parameter` - the parameter to be removed
      Returns:
        the parameter to be removed

    - #### setQuery

          public void setQuery(JRDesignQuery query)

      Sets the dataset query.
      Parameters:
        `query` - the query
      See Also:
        `JRDataset.getQuery()`

    - #### setScriptletClass

          public void setScriptletClass(java.lang.String scriptletClass)

      Sets the scriptlet class name.

      If no scriptlet class name is specified, a default scriptlet is used.

      Parameters:
        `scriptletClass` - the class name of the scriptlet
      See Also:
        `JRDataset.getScriptletClass()`

    - #### getFields

          public JRField[] getFields()

      Description copied from interface: `JRDataset`
      Returns the dataset's fields.
      Specified by:
        `getFields` in interface `JRDataset`
      Overrides:
        `getFields` in class `JRBaseDataset`
      Returns:
        the dataset's fields

    - #### getFieldsList

          public java.util.List<JRField> getFieldsList()

      Returns the list of fields.
      Returns:
        list of `JRField` objects

    - #### getFieldsMap

          public java.util.Map<java.lang.String,JRField> getFieldsMap()

      Returns the map of fields indexed by name.
      Returns:
        `JRField` objects indexed by name

    - #### addField

          public void addField(JRField field)
                        throws JRException

      Adds a field to the dataset.
      Parameters:
        `field` - the field to add
      Throws:
        `JRException`
      See Also:
        `JRDataset.getFields()`

    - #### addField

          public void addField(int index,
                      JRField field)
                        throws JRException

      Inserts a field at the specified position into the dataset.
      Parameters:
        `index` - the field position
        `field` - the field to insert
      Throws:
        `JRException`
      See Also:
        `JRDataset.getFields()`

    - #### removeField

          public JRField removeField(java.lang.String fieldName)

      Removes a field from the dataset.
      Parameters:
        `fieldName` - the field name
      Returns:
        the removed field, or `null` if the field was not found

    - #### removeField

          public JRField removeField(JRField field)

      Removes a field from the dataset.
      Parameters:
        `field` - the field to be removed
      Returns:
        the field to be removed

    - #### getSortFields

          public JRSortField[] getSortFields()

      Description copied from interface: `JRDataset`
      Returns the dataset's sort fields.
      Specified by:
        `getSortFields` in interface `JRDataset`
      Overrides:
        `getSortFields` in class `JRBaseDataset`
      Returns:
        the dataset's sort fields

    - #### getSortFieldsList

          public java.util.List<JRSortField> getSortFieldsList()

      Returns the list of sort fields.
      Returns:
        list of `JRSortField` objects

    - #### getSortFieldsMap

          public java.util.Map<java.lang.String,JRSortField> getSortFieldsMap()

      Returns the map of sort fields indexed by name and type.
      Returns:
        `JRField` objects indexed by name

    - #### addSortField

          public void addSortField(JRSortField sortField)
                            throws JRException

      Adds a sort field to the dataset.
      Parameters:
        `sortField` - the sort field to add
      Throws:
        `JRException`
      See Also:
        `JRDataset.getSortFields()`

    - #### addSortField

          public void addSortField(int index,
                          JRSortField sortField)
                            throws JRException

      Inserts a sort field at specified position into the dataset.
      Parameters:
        `index` - the sort field position
        `sortField` - the sort field to insert
      Throws:
        `JRException`
      See Also:
        `JRDataset.getSortFields()`

    - #### removeSortField

          public JRSortField removeSortField(java.lang.String fieldName)

      Deprecated. To be removed.
      Removes a sort field from the dataset.
      Parameters:
        `fieldName` - the field name
      Returns:
        the removed sort field, or `null` if the sort field was not found

    - #### removeSortField

          public JRSortField removeSortField(JRSortField sortField)

      Removes a sort field from the dataset.
      Parameters:
        `sortField` - the sort field to be removed
      Returns:
        the sort field to be removed

    - #### getVariables

          public JRVariable[] getVariables()

      Description copied from interface: `JRDataset`
      Returns the dataset's variables.
      Specified by:
        `getVariables` in interface `JRDataset`
      Overrides:
        `getVariables` in class `JRBaseDataset`
      Returns:
        the dataset's variables

    - #### getVariablesList

          public java.util.List<JRVariable> getVariablesList()

      Returns the list of variables, including build-in ones.
      Returns:
        list of `JRVariable` objects

    - #### getVariablesMap

          public java.util.Map<java.lang.String,JRVariable> getVariablesMap()

      Returns the map of variable, including build-in ones, indexed by name.
      Returns:
        `JRVariable` objects indexed by name

    - #### addVariable

          public void addVariable(JRDesignVariable variable)
                           throws JRException

      Adds a variable to the dataset.
      Parameters:
        `variable` - the variable to add
      Throws:
        `JRException`
      See Also:
        `JRDataset.getVariables()`

    - #### addVariable

          public void addVariable(int index,
                         JRDesignVariable variable)
                           throws JRException

      Inserts a variable at specified position into the dataset.
      Parameters:
        `index` - the variable position
        `variable` - the variable to insert
      Throws:
        `JRException`
      See Also:
        `JRDataset.getVariables()`

    - #### addVariable

          protected void addVariable(JRDesignVariable variable,
                         boolean system)
                              throws JRException

      Adds a variable to the dataset.
      Parameters:
        `variable` - the variable to add
        `system` - whether the variable should be added before user defined variables or at the end of the variables list
      Throws:
        `JRException`

    - #### addVariable

          protected void addVariable(int index,
                         JRDesignVariable variable,
                         boolean system)
                              throws JRException

      Inserts a variable at specified position into the dataset.
      Parameters:
        `index` - the variable position
        `variable` - the variable to insert
        `system` - whether the variable should be inserted before user defined variables or at the end of the variables list
      Throws:
        `JRException`

    - #### removeVariable

          public JRVariable removeVariable(java.lang.String variableName)

      Removes a variable from the dataset.
      Parameters:
        `variableName` - the variable name
      Returns:
        the removed variable, or `null` if the variable was not found

    - #### removeVariable

          public JRVariable removeVariable(JRVariable variable)

      Removes a variable from the dataset.
      Parameters:
        `variable` - the variable to be removed
      Returns:
        the variable to be removed

    - #### getGroups

          public JRGroup[] getGroups()

      Description copied from interface: `JRDataset`
      Returns the dataset's groups.
      Specified by:
        `getGroups` in interface `JRDataset`
      Overrides:
        `getGroups` in class `JRBaseDataset`
      Returns:
        the dataset's groups

    - #### getGroupsList

          public java.util.List<JRGroup> getGroupsList()

      Returns the list of groups.
      Returns:
        list of `JRGroup` objects

    - #### getGroupsMap

          public java.util.Map<java.lang.String,JRGroup> getGroupsMap()

      Returns the map of groups indexed by name.
      Returns:
        `JRGroup` objects indexed by name

    - #### addGroup

          public void addGroup(JRDesignGroup group)
                        throws JRException

      Adds a group to the dataset.
      Parameters:
        `group` - the group to add
      Throws:
        `JRException`
      See Also:
        `JRDataset.getGroups()`

    - #### addGroup

          public void addGroup(int index,
                      JRDesignGroup group)
                        throws JRException

      Inserts a group at the specified position into the dataset.
      Parameters:
        `index` - the group position
        `group` - the group to insert
      Throws:
        `JRException`
      See Also:
        `JRDataset.getGroups()`

    - #### removeGroup

          public JRGroup removeGroup(java.lang.String groupName)

      Removes a group from the dataset.
      Parameters:
        `groupName` - the group name
      Returns:
        the removed group, or `null` if the group was not found

    - #### removeGroup

          public JRGroup removeGroup(JRGroup group)

      Removes a group from the dataset.
      Parameters:
        `group` - the group to be removed
      Returns:
        the group to be removed

    - #### setResourceBundle

          public void setResourceBundle(java.lang.String resourceBundle)

      Sets the base name of resource bundle to be used by the dataset.
      Parameters:
        `resourceBundle` - the resource bundle base name

    - #### queryLanguageChanged

          protected void queryLanguageChanged(java.lang.String oldLanguage,
                                  java.lang.String newLanguage)

    - #### setProperty

          public void setProperty(java.lang.String propName,
                         java.lang.String value)

      Adds/sets a property value.
      Parameters:
        `propName` - the name of the property
        `value` - the value of the property

    - #### setFilterExpression

          public void setFilterExpression(JRExpression expression)

      Sets the dataset filter expression.

      The expression value class should be `java.lang.Boolean`.

      Parameters:
        `expression` - the boolean expression to use as filter expression
      See Also:
        `JRDataset.getFilterExpression()`

    - #### clone

          public java.lang.Object clone()

      Specified by:
        `clone` in interface `JRCloneable`
      Overrides:
        `clone` in class `JRBaseDataset`

© 2001-2010 Jaspersoft Corporation www.jaspersoft.com